#Asteroids clone
import pyglet, random
import resources, physicalobject, player

window = pyglet.window.Window(800,600)
mbatch = pyglet.graphics.Batch()
deadbatch = pyglet.graphics.Batch()

#Initialize some variables
gamevars = {'lives':0, 'level' : 1, 'lives' : 3, 'score':0, 'retval':''}

info_label = pyglet.text.Label(text="Score: "+str(gamevars['score'])+" Level: "+str(gamevars['level']), x=10, y=575, batch=mbatch)
life_label = pyglet.text.Label(text="Lives:", x=785-(gamevars['lives']*40), y=575, batch=mbatch)

playership = player.Player(x=400, y=300, batch=mbatch)
asteroids = resources.make_asteroids(gamevars['level']+2, playership.position, mbatch)
gamevars['life_left'] = resources.lives_remain(gamevars['lives'],mbatch)
anykey = False

gameobjects = [playership] + asteroids
window.push_handlers(playership)
window.push_handlers(playership.key_handler)

def update(dt):
	global gamevars
	
	#update Asteroids
	to_remove = []
	
	if len(asteroids) <= 0:
		if resources.levelComplete(playership, gamevars['level'], asteroids, mbatch) == True:
			gamevars['level'] += 1
			info_label.text = "Score: "+str(gamevars['score'])+" Level: "+str(gamevars['level'])

		
		
	for obj in asteroids:

		#check Bullet -> Asteroid Collisions
		for blt in playership.bullets:
			if blt.check_collide(obj) and obj.react_to_bullets == True and blt.dead == False:
				blt.handle_collision(obj)
				obj.handle_collision(blt)
				obj.die()
				to_remove.append(obj)
				
				#a bullet hit an asteroid: Make smaller asteroids if they are big (obj.asize)
				#also increase the score accordingly
				if obj.asize == 1: #big
					gamevars['score'] += 10
							
					#The code below adds new asteroids but at a random position + velocity, need to fix that!
					asteroids.extend(resources.make_small_asteroids(2,playership.position,obj,mbatch))
				if obj.asize == 2: #small
					gamevars['score'] += 5
				
				info_label.text = "Score: "+str(gamevars['score'])+" Level: "+str(gamevars['level'])
		
		#player collision with asteroids
		if obj.check_collide(playership) == True and playership.visible == True:
			playership.die()
			gamevars['lives'] -= 1
			gamevars['life_left'].pop(gamevars['lives'])
	

		
		#finally the object's update call
		obj.update(dt)
	
	#update bullets
	for blt in playership.bullets:
		blt.update(dt, playership.bullets)
		
	#update Ship
	playership.update(dt)

	#if the playership is dead, the game is over or hasn't started. So let's rectify that...
	gamevars['retval'] = resources.checkDead(playership, gamevars, asteroids, deadbatch)
	if gamevars['retval'] == 2 and playership.dead == False:
		#print "BEFORE: " + str(asteroids) - this was here for debugging
		new_remove = []
		for old in asteroids:
			new_remove.append(old)
			old.delete()
		asteroids.remove(new_remove[0])
		del asteroids[:]
		asteroids.extend(resources.GameOver(gamevars, asteroids, playership, mbatch))
		#print "AFTER: " + str(asteroids)	- debugging
		
				
	if len(to_remove) > 0:
		delast = to_remove[0]
		asteroids.remove(delast)
	
	

@window.event
def on_draw():
	global gamevars
	window.clear()
	mbatch.draw()
	deadbatch.draw()
	
	
	if playership.levelcomplete == True:
		lvl_label = pyglet.text.Label(text="Level complete. Press spacebar to continue!", x=275, y=400)
		lvl_label.draw()
		
	if gamevars['retval'] == 1:
		start_label = pyglet.text.Label(text="You died. Press Space to Restart!", x=300, y=300)
		start_label.draw()
	if gamevars['retval'] == 2: 
		start_label = pyglet.text.Label(text="Game Over. Press Space to Restart!", x=300, y=300)
		start_label.draw()



if __name__ == '__main__':
	pyglet.clock.schedule_interval(update, 1/120.0)
	pyglet.app.run()